
function [r_score,n_score] = embedding_scores(Y_embed,distances_geodesic)

n = size(Y_embed,2);

K = 10;
distances_Y_embed = L2_distance(Y_embed, Y_embed, 1);
[Y,~,~] = Isomap2(distances_Y_embed,'k',K);

% RV computation
dim = 10;
r_score = zeros(1,dim);

for di=1:dim,
    distances_subsampled_manifold = L2_distance(Y.coords{di},Y.coords{di},1);
    r2 = 1-corrcoef(distances_geodesic(:),distances_subsampled_manifold(:)).^2;
    r_score(di) = r2(2,1);
end

% NN computation
distances_Y = L2_distance(Y.coords{3},Y.coords{3},1);

%max_neighbors = 10;
max_neighbors = 5;

% Compute neighborliness metric
n_score = zeros(1,max_neighbors);

for i=1:max_neighbors
    for j=1:n,
        neighbors_full_geodesic = GeodesicNearestNeighbors(distances_geodesic,j, 10*i);
        neighbors_subsampled_manifold = GeodesicNearestNeighbors(distances_Y,j, 10*i);
        n_score(i) = n_score(i) + 10*i - length(setdiff(neighbors_full_geodesic,neighbors_subsampled_manifold));
    end
end
n_score = n_score./(10*n*(1:max_neighbors));