
function [error1,error2,error3] = isomap_out_of_sample_function(X,K,n_dimensions,omega,n_pixels)


%load X_eyedata.mat;
%load X_eyedata_handlabel.mat;
%load X_eyedata_full.mat;
%load X_eyedata_full_handlabel.mat;

d = size(X,1);
n = size(X,2);

%n_dimensions = 2;

distances_ambient = L2_distance(X, X, 1);
[Y_isomap, ~, ~] = IsomapII_prime(distances_ambient, 'k', K);
Y_original = Y_isomap.coords{n_dimensions};

% number of iterations of random masking
S = 2;
error_temp = zeros(S,n);
error_full = zeros(1,n);
error_masked = zeros(1,n);

for i = 1:n
    perccount(i,n)       
    
    samples = setdiff(1:n,i);    
    options.landmarks = samples;
    [Y_full, ~, ~] = IsomapII_prime(distances_ambient, 'k', K, options);
    Y = Y_full.coords{n_dimensions};
    y = Y(:,i);
        
    [~,~,T] = procrustes(Y_original(:,samples)',Y(:,samples)');    
    error_full(i) = norm( (T.b * y' * T.T + T.c(1,:)) - Y_original(:,i)' ,2);
    
    X_masked = X(omega,:);
    distances_masked = L2_distance(X_masked, X_masked, 1);
    [Y_1, ~, ~] = IsomapII_prime(distances_masked, 'k', K, options);
    Y_masked = Y_1.coords{n_dimensions};
    y_masked = Y_masked(:,i);
    
    [~,~,T_masked] = procrustes(Y_original(:,samples)',Y_masked(:,samples)');
    error_masked(i) = norm( ( T_masked.b * y_masked' * T_masked.T + T_masked.c(1,:) ) - Y_original(:,i)' ,2);
    
    for t = 1:S
        omega_random = randperm(d,n_pixels);
        X_random = X(omega_random,:);
        distances_random = L2_distance(X_random, X_random, 1);
        
        try
            [Y_2, ~, ~] = IsomapII_prime(distances_random, 'k', K, options);
            Y_random = Y_2.coords{n_dimensions};
            y_random = Y_random(:,i);
            [~,~,T_random] = procrustes(Y_original(:,samples)',Y_random(:,samples)');
            error_temp(t,i) = norm( ( T_random.b * y_random' * T_random.T + T_random.c(1,:) ) - Y_original(:,i)' ,2);    
        catch
            t = t - 1; %#ok<FXSET>
            continue
        end
    end
    
    
end

error_random = sum(error_temp,1) / S;

error1 = mean(error_full);
error2 = mean(error_masked);
error3 = mean(error_random); 
