
function [error1,error2,error3] = LLE_out_of_sample_extension_localfit(X,omega,K,n_dimensions)

%clear all;

%load X_eyedata.mat;
%load X_MNIST.mat;
%load X_squares.mat;
%load X_faces.mat;

%X = double(X);
d = size(X,1);
n = size(X,2);

%m = 50:50:250;
%m = 50;
m = length(omega);

%K = 12;
%n_dimensions = 2;

%omega = omega(1:m);
X_masked = X(omega,:);

%Y_original = lle(X,K,n_dimensions);

[W,neighborhood] = mapping_weights(X,K);
[W_masked,neighborhood_masked] = mapping_weights(X_masked,K);

error_full = zeros(1,n);
error_masked = zeros(1,n);

neighbors_set = cell(n,1);
for i = 1 : n
    neighbors = neighborhood(:,i);
    index_set = find( sum(neighborhood(:,neighborhood(:,i)) == i , 1 ));  
    neighbors_set{i} = union(neighbors(index_set),i); %#ok<FNDSB>
end

exception_ind = [];

for i = 1 : n
    perccount(i,n)
    
    samples = setdiff(1:n,i);
    
    % full data
    Z = X(:,samples);    
    Y = lle(Z,K,n_dimensions);
    
    neighbors = neighborhood(:,i); 
    %neighbors_original = neighbors;
    neighbors(neighbors > i) = neighbors(neighbors > i) - 1;   
    
    y = Y(:,neighbors) * W(:,i);
    
    %index_set = find( sum(neighborhood(:,neighborhood(:,i)) == i , 1 ));  
    %neighbors_set = union(neighbors_original(index_set),i); %#ok<FNDSB>
    
    Y = [Y(:,1:i-1) y Y(:,i:end)];
    %error_full(i) = norm(Y_original(:,i) - y,2)^2;
    error_full(i) = 0;
    for j = 1 : length(neighbors_set{i})
        error_full(i) = error_full(i) + norm(Y(:,neighbors_set{i}(j)) ...
        - sum(repmat(W(:,neighbors_set{i}(j))',n_dimensions,1).*Y(:,neighborhood(:,neighbors_set{i}(j))),2),2)^2;
    end
    
    % masked data
    Z_masked = X_masked(:,samples);     
    try
        Y_masked = lle(Z_masked,K,n_dimensions);
    catch
        exception_ind = [exception_ind i]; %#ok<AGROW>
        display('had to skip the masked loop!')
        continue
    end
    
    neighbors_masked = neighborhood_masked(:,i);
    neighbors_masked(neighbors_masked > i) = neighbors_masked(neighbors_masked > i) - 1;    
    
    y_masked = Y_masked(:,neighbors_masked) * W_masked(:,i);    
        
    Y_masked = [Y_masked(:,1:i-1) y_masked Y_masked(:,i:end)];    
    %error_masked(i) = norm(Y_original(:,i) - y_masked,2)^2;
    error_masked(i) = 0;
    for j = 1 : length(neighbors_set{i})
        error_masked(i) = error_masked(i) + norm(Y_masked(:,neighbors_set{i}(j)) ...
        - sum(repmat(W(:,neighbors_set{i}(j))',n_dimensions,1).*Y_masked(:,neighborhood(:,neighbors_set{i}(j))),2),2)^2;
    end
    
end

% number of iterations of random masking
S = 10;
%S = 2;
error_temp = zeros(S,n);

for t = 1:S
    perccount(t,S)
    
    omega_random = randperm(d,m);
    X_random = X(omega_random,:);
    
    [W_random,neighborhood_random] = mapping_weights(X_random,K);
        
    for i = 1:n        
        samples = setdiff(1:n,i);
        
        Z_random = X_random(:,samples);
        
        try
            Y_random = lle(Z_random,K,n_dimensions);
        catch
            t = t - 1; %#ok<FXSET>
            display('had to repeat the random loop!')
            break
        end
        
        neighbors_random = neighborhood_random(:,i);
        %neighbors_random_original = neighbors_random;
        neighbors_random(neighbors_random > i) = neighbors_random(neighbors_random > i) - 1;        
        
        y_random = Y_random(:,neighbors_random) * W_random(:,i);                
        
        %{
        index_set = find( sum(neighborhood_random(:,neighbors_random) == i , 1 ));  
        index_set_prime = find( sum(neighborhood_random(:,neighborhood_random(:,i)) == i , 1 )); 
        error_temp(t,i) = norm(Y_original(:,i) - y_random,2)^2;
        for j = 1 : length(index_set)
            error_temp(t,i) = error_temp(t,i) + norm(Y_random(:,neighbors_random(index_set(j))) ...
                - sum(repmat(W(:,neighbors_random_original(:,index_set_prime(j)))',n_dimensions,1).*Y_random(:,neighborhood_random(:,neighbors_random(index_set(j)))),2),2)^2;
        end
        %}
        
        Y_random = [Y_random(:,1:i-1) y_random Y_random(:,i:end)];            
        error_temp(t,i) = 0;
        for j = 1 : length(neighbors_set{i})
            error_temp(t,i) = error_temp(t,i) + norm(Y_random(:,neighbors_set{i}(j)) ...
                - sum(repmat(W(:,neighbors_set{i}(j))',n_dimensions,1).*Y_random(:,neighborhood(:,neighbors_set{i}(j))),2),2)^2;
        end
        
    end       
    
end

error_random = sum(error_temp,1) / S;

error1 = mean(error_full);
error2 = mean(error_masked);
error3 = mean(error_random);

%{
display(mean(error_full))
display(mean(error_masked))
display(mean(error_random))
%}
